ConstructorProperties (Java Platform SE 8 )
Keywords: java.beans.ConstructorProperties class
Date: 2026-04-17

java.beans

## Annotation Type ConstructorProperties

-     @Documented
       @Target(value=CONSTRUCTOR)
       @Retention(value=RUNTIME)
      public @interface ConstructorProperties

  An annotation on a constructor that shows how the parameters of that constructor correspond to the constructed object's getter methods. For example:

  >        public class Point {
  >            @ConstructorProperties({"x", "y"})
  >            public Point(int x, int y) {
  >                this.x = x;
  >                this.y = y;
  >            }

  >            public int getX() {
  >                return x;
  >            }

  >            public int getY() {
  >                return y;
  >            }

  >            private final int x, y;
  >        }

  The annotation shows that the first parameter of the constructor can be retrieved with the `getX()` method and the second with the `getY()` method. Since parameter names are not in general available at runtime, without the annotation there would be no way to know whether the parameters correspond to `getX()` and `getY()` or the other way around.
  Since:
    1.6

- - ### Required Element Summary

    Required Elements
    Modifier and Type | Required Element and Description
    --- | ---
    `String[]` | `value` The getter names.

- - ### Element Detail

    - #### value

          public abstract String[] value

      The getter names.

      Returns:
        the getter names corresponding to the parameters in the annotated constructor.

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2026, Oracle and/or its affiliates. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.